BaseInterface = require './BaseInterface'

class InterfaceManager extends BaseInterface
  constructor: (@_interfaces = []) ->

InterfaceManager::subscribe = (channel, callback, _interfaces = @_interfaces) ->
  for _interface in _interfaces
    _interface.subscribe channel, (data) =>
      callback data

InterfaceManager::unsubscribe = (channel, _interfaces = @_interfaces) ->
  for _interface in _interfaces
    _interface.unsubscribe channel

InterfaceManager::get = (channel, callback) ->
  for _interface in @_interfaces
    _interface.get channel, (data) =>
      callback data

InterfaceManager::request = (channel, data, _interfaceName = @_interfaces[0].constructor.name || null) ->
  for _interface in @_interfaces
    if _interface.constructor.name == _interfaceName
      return _interface.request channel, data

InterfaceManager::publish = (channel, data, _interfaceName = @_interfaces[0].constructor.name || null) ->
  for _interface in @_interfaces
    if _interface.constructor.name == _interfaceName
      return _interface.publish channel, data

module.exports = InterfaceManager


# Intersubscribe: (channel, callback) ->