log4js = require 'log4js'
logger = log4js.getLogger 'Request'

class Request
  constructor: (@data = null, @key = @generateKey(), @timeout = 5000) ->
    @type = 'request'
    @responseChannel = 'response_channel_' + @key
Request::generateKey = ->
  Math.floor(Math.random()*1000*1000*1000*1000*1000*1000).toString(32) +  Math.floor(Math.random()*1000*1000*1000*1000*1000*1000).toString(32)

Request::toJson = ->
  try
    JSON.stringify
      key: @key
      type: @type
      data: @data
  catch e
    return ""

Request.parse = (data) ->
  try
    if typeof data == 'string' then  data = JSON.parse data
    if data && data.type == 'request'
      return new Request data.data, data.key
  catch e
    logger.warn 'parsing error: ' + e.message
  return null

module.exports = Request