log4js = require 'log4js'
logger = log4js.getLogger 'Response'

class Response
  constructor: (@key, @data = null, @status = 200) ->
    @type = 'response'
    @success = false
    if Math.floor(@status / 100) == 2
      @success = true
Response::toJson = ->
  try
    JSON.stringify
      key: @key
      type: @type
      data: @data
      status: @status
  catch e
    return ""

Response.parse = (data, request) ->
  try
    if typeof data == 'string' then  data = JSON.parse data
    if data && data.type == 'response' && request.key == data.key
      return new Response data.key, data.data, data.status
  catch e
    console.l
    logger.warn 'parsing error: ' + e.message
  return null

module.exports = Response